`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company:       UPB
// Engineer:      Dan Dragomir
//
// Create Date:   15:51:30 30/10/2018
// Design Name:   tester combinational
// Module Name:   tester
// Project Name:  practical test
// Target Device: ISim
// Tool versions: 14.6
// Description:   tester for combinational module
////////////////////////////////////////////////////////////////////////////////

module adapter(out_uut, out_ref, in);

`include "adapter.inc"

output [`OUTPUT_WIDTH-1 : 0] out_uut;
output [`OUTPUT_WIDTH-1 : 0] out_ref;
input  [`INPUT_WIDTH-1 : 0]  in;

//// adapt this
adder11 uut (
    .a(in[10:0]),
    .b(in[21:11]),
    .sum(out_uut[11:0])
);

ref_adder11 ref (
    .a(in[10:0]),
    .b(in[21:11]),
    .sum(out_ref[11:0])
);
////

endmodule
